Name:           ros-kilted-nav2-costmap-2d
Version:        1.4.0
Release:        1%{?dist}
Summary:        ROS package nav2-costmap-2d

License:        BSD-3-Clause
URL:            http://www.ros.org/

Source0:        https://github.com/ros2-gbp/navigation2-release/archive/release/kilted/nav2_costmap_2d/1.4.0-1.tar.gz#/ros-kilted-nav2-costmap-2d-1.4.0-source0.tar.gz



# common BRs
BuildRequires: patchelf
BuildRequires: coreutils
BuildRequires: cmake
BuildRequires: gcc-c++
BuildRequires: git
BuildRequires: make
BuildRequires: patch
BuildRequires: python3-devel
BuildRequires: python-unversioned-command
BuildRequires: python3-colcon-common-extensions
BuildRequires: python3-pip
BuildRequires: python3-pydocstyle
BuildRequires: python3-pytest
BuildRequires: python3-pytest-repeat
BuildRequires: python3-pytest-rerunfailures
BuildRequires: python3-rosdep
BuildRequires: python3-setuptools
BuildRequires: python3-vcstool

# BuildRequires:  boost-devel
# BuildRequires:  console-bridge-devel
# BuildRequires:  gtest-devel
# BuildRequires:  log4cxx-devel
# BuildRequires:  python3-devel
# BuildRequires:  python3-colcon-common-extensions
# BuildRequires:  python-unversioned-command

BuildRequires:  ros-kilted-ament-cmake
BuildRequires:  ros-kilted-ament-package
BuildRequires:  ros-kilted-angles
BuildRequires:  ros-kilted-geometry-msgs
BuildRequires:  ros-kilted-laser-geometry
BuildRequires:  ros-kilted-map-msgs
BuildRequires:  ros-kilted-message-filters
BuildRequires:  ros-kilted-nav2-common
BuildRequires:  ros-kilted-nav2-msgs
BuildRequires:  ros-kilted-nav2-util
BuildRequires:  ros-kilted-nav2-voxel-grid
BuildRequires:  ros-kilted-nav-msgs
BuildRequires:  ros-kilted-pluginlib
BuildRequires:  ros-kilted-rclcpp
BuildRequires:  ros-kilted-rclcpp-lifecycle
BuildRequires:  ros-kilted-rmw
BuildRequires:  ros-kilted-sensor-msgs
BuildRequires:  ros-kilted-std-msgs
BuildRequires:  ros-kilted-std-srvs
BuildRequires:  ros-kilted-tf2
BuildRequires:  ros-kilted-tf2-geometry-msgs
BuildRequires:  ros-kilted-tf2-ros
BuildRequires:  ros-kilted-tf2-sensor-msgs
BuildRequires:  ros-kilted-visualization-msgs

Requires:       ros-kilted-angles
Requires:       ros-kilted-geometry-msgs
Requires:       ros-kilted-laser-geometry
Requires:       ros-kilted-map-msgs
Requires:       ros-kilted-message-filters
Requires:       ros-kilted-nav2-msgs
Requires:       ros-kilted-nav2-util
Requires:       ros-kilted-nav2-voxel-grid
Requires:       ros-kilted-nav-msgs
Requires:       ros-kilted-pluginlib
Requires:       ros-kilted-rclcpp
Requires:       ros-kilted-rclcpp-lifecycle
Requires:       ros-kilted-rmw
Requires:       ros-kilted-sensor-msgs
Requires:       ros-kilted-std-msgs
Requires:       ros-kilted-std-srvs
Requires:       ros-kilted-tf2
Requires:       ros-kilted-tf2-geometry-msgs
Requires:       ros-kilted-tf2-ros
Requires:       ros-kilted-tf2-sensor-msgs
Requires:       ros-kilted-visualization-msgs

Requires:       ros-kilted-ament-cmake
Requires:       ros-kilted-ament-package
Requires:       ros-kilted-angles
Requires:       ros-kilted-geometry-msgs
Requires:       ros-kilted-laser-geometry
Requires:       ros-kilted-map-msgs
Requires:       ros-kilted-message-filters
Requires:       ros-kilted-nav2-common
Requires:       ros-kilted-nav2-msgs
Requires:       ros-kilted-nav2-util
Requires:       ros-kilted-nav2-voxel-grid
Requires:       ros-kilted-nav-msgs
Requires:       ros-kilted-pluginlib
Requires:       ros-kilted-rclcpp
Requires:       ros-kilted-rclcpp-lifecycle
Requires:       ros-kilted-rmw
Requires:       ros-kilted-sensor-msgs
Requires:       ros-kilted-std-msgs
Requires:       ros-kilted-std-srvs
Requires:       ros-kilted-tf2
Requires:       ros-kilted-tf2-geometry-msgs
Requires:       ros-kilted-tf2-ros
Requires:       ros-kilted-tf2-sensor-msgs
Requires:       ros-kilted-visualization-msgs

Provides:  ros-kilted-nav2-costmap-2d = 1.4.0-1
Obsoletes: ros-kilted-nav2-costmap-2d < 1.4.0-1


%description
This package provides an implementation of a 2D costmap that takes in
sensor data from the world, builds a 2D or 3D occupancy grid of the
data (depending on whether a voxel based implementation is used), and
inflates costs in a 2D costmap based on the occupancy grid and a user
specified inflation radius. This package also provides support for
map_server based initialization of a costmap, rolling window based
costmaps, and parameter based subscription to and configuration of
sensor topics.




%prep

%setup -c -T
tar --strip-components=1 -xf %{SOURCE0}

%build
# nothing to do here


%install

PYTHONUNBUFFERED=1 ; export PYTHONUNBUFFERED
GZ_BUILD_FROM_SOURCE=1; export GZ_BUILD_FROM_SOURCE
export GZ_VERSION=harmonic;

CFLAGS=" -Wno-error ${CFLAGS:-%optflags} -Wno-error -w -Wno-error=int-conversion" ; export CFLAGS ; \
CXXFLAGS=" -Wno-error ${CXXFLAGS:-%optflags} -Wno-error -w -Wno-error=int-conversion" ; export CXXFLAGS ; \
FFLAGS=" -Wno-error ${FFLAGS:-%optflags%{?_fmoddir: -I%_fmoddir}} -w -Wno-error=int-conversion" ; export FFLAGS ; \
FCFLAGS="${FCFLAGS:-%optflags%{?_fmoddir: -I%_fmoddir}} -w -Wno-error=int-conversion" ; export FCFLAGS ; \
%{?__global_ldflags:LDFLAGS="${LDFLAGS:-%__global_ldflags}" ; export LDFLAGS ;} \

source %{_libdir}/ros-kilted/setup.bash

# substitute shebang before install block because we run the local catkin script
%py3_shebang_fix .

# DESTDIR=%{buildroot} ; export DESTDIR

colcon \
  build \
  --merge-install \
  --cmake-args -DPYTHON_EXECUTABLE="/usr/bin/python" \
  -DTHIRDPARTY_Asio=ON \
  -DCMAKE_BUILD_TYPE=RelWithDebInfo \
  -DCMAKE_CXX_FLAGS="$CXXFLAGS" \
  -DCMAKE_C_FLAGS="$CFLAGS" \
  -DCMAKE_LD_FLAGS="$LDFLAGS" \
  -DBUILD_TESTING=OFF \
  -Dgz_add_get_install_prefix_impl_OVERRIDE_INSTALL_PREFIX_ENV_VARIABLE="%{_libdir}/ros-kilted/opt/" \
  --base-paths . \
  --install-base %{buildroot}/%{_libdir}/ros-kilted/ \
  --packages-select nav2_costmap_2d



# remove wrong buildroot prefixes
# find %{buildroot}/%{_libdir}/ros-kilted/ -type f -exec sed -i "s:%{buildroot}::g" {} \;
# we should exclude binaries from that as it might corrupt shared libraries
find %{buildroot}/%{_libdir}/ros-kilted/ -type f ! -name '*.so*' -exec sh -c 'file "{}" | grep -q text && sed -i "s:%{buildroot}::g" "{}"' \;

# # Move include directory if source path exists
# if [ -d %{buildroot}/%{_libdir}/ros-kilted/opt/nav2_costmap_2d/include ]; then
#     # If destination path does not exist, create it
#     if [ ! -d %{buildroot}/%{_libdir}/ros-kilted/include/nav2_costmap_2d ]; then
#         mkdir -p %{buildroot}/%{_libdir}/ros-kilted/include/nav2_costmap_2d
#     fi
#     # Move the directory
#     cp -r %{buildroot}/%{_libdir}/ros-kilted/opt/nav2_costmap_2d/include/* %{buildroot}/%{_libdir}/ros-kilted/include/nav2_costmap_2d/
#     rm -rd %{buildroot}/%{_libdir}/ros-kilted/opt/nav2_costmap_2d/include
# fi

# if [ -d %{buildroot}/%{_libdir}/ros-kilted/opt/nav2_costmap_2d/extra_cmake ]; then
#     # If destination path does not exist, create it
#     if [ ! -d %{buildroot}/%{_libdir}/ros-kilted/nav2_costmap_2d/extra_cmake ]; then
#         mkdir -p %{buildroot}/%{_libdir}/ros-kilted/nav2_costmap_2d/extra_cmake
#     fi
#     # Move the directory
#     cp -r %{buildroot}/%{_libdir}/ros-kilted/opt/nav2_costmap_2d/extra_cmake/* %{buildroot}/%{_libdir}/ros-kilted/nav2_costmap_2d/extra_cmake/
#     rm -rd %{buildroot}/%{_libdir}/ros-kilted/opt/nav2_costmap_2d/extra_cmake
# fi

# if [ -d %{buildroot}/%{_libdir}/ros-kilted/nav2_costmap_2d/share ]; then
#     # If destination path does not exist, create it
#     if [ ! -d %{buildroot}/%{_libdir}/ros-kilted/share/nav2_costmap_2d ]; then
#         mkdir -p %{buildroot}/%{_libdir}/ros-kilted/share/nav2_costmap_2d
#     fi
#     # Move the directory
#     cp -r %{buildroot}/%{_libdir}/ros-kilted/nav2_costmap_2d/share/* %{buildroot}/%{_libdir}/ros-kilted/share/nav2_costmap_2d/
#     rm -rd %{buildroot}/%{_libdir}/ros-kilted/nav2_costmap_2d/share
# fi

# # Move other opt path if source path exists
# if [ -d %{buildroot}/%{_libdir}/ros-kilted/opt/nav2_costmap_2d]; then
#     # If destination path does not exist, create it
#     if [ ! -d %{buildroot}/%{_libdir}/ros-kilted ]; then
#         mkdir -p %{buildroot}/%{_libdir}/ros-kilted
#     fi
#     # Move the directory
#     cp -r %{buildroot}/%{_libdir}/ros-kilted/opt/nav2_costmap_2d/* %{buildroot}/%{_libdir}/ros-kilted/
#     rm  -rd %{buildroot}/%{_libdir}/ros-kilted/opt/nav2_costmap_2d
# fi

rm -rf %{buildroot}/%{_libdir}/ros-kilted/{.catkin,.rosinstall,_setup*,local_setup*,setup*,env.sh,.colcon_install_layout,COLCON_IGNORE,_local_setup*,_local_setup*}

# vendor pkg removal
rm -rf %{buildroot}/%{_libdir}/ros-kilted/opt/share/nav2_costmap_2d/{.catkin,.rosinstall,_setup*,local_setup*,setup*,env.sh,.colcon_install_layout,COLCON_IGNORE,_local_setup*,_local_setup*}

# remove __pycache__
find %{buildroot} -type d -name '__pycache__' -exec rm -rf {} +
find . -name '*.pyc' -delete

touch files.list
find %{buildroot}/%{_libdir}/ros-kilted/{share,bin,etc,tools,lib64/python*,lib/python*/site-packages,lib/python*/dist-packages} \
  ! -name cmake ! -name include \
  -mindepth 1 -maxdepth 1 | sed "s:%{buildroot}/::" > files.list
find %{buildroot}/%{_libdir}/ros-kilted/lib*/ -mindepth 1 -maxdepth 1 \
  ! -name pkgconfig ! -name "python*" \
  | sed "s:%{buildroot}/::" >> files.list

# paths for vendor packages
find %{buildroot}/%{_libdir}/ros-kilted/nav2_costmap_2d/{bin,etc,tools,lib64/python*,lib/python*/site-packages,share} \
  ! -name cmake ! -name include \
  -mindepth 1 -maxdepth 1 | sed "s:%{buildroot}/::" >> files.list
find %{buildroot}/%{_libdir}/ros-kilted/opt/nav2_costmap_2d/{bin,etc,tools,lib64/python*,lib/python*/site-packages,share} \
  ! -name cmake ! -name include \
  -mindepth 1 -maxdepth 1 | sed "s:%{buildroot}/::" >> files.list
find %{buildroot}/%{_libdir}/ros-kilted/nav2_costmap_2d/lib*/ -mindepth 1 -maxdepth 1 \
  ! -name pkgconfig ! -name "python*" \
  | sed "s:%{buildroot}/::" >> files.list
find %{buildroot}/%{_libdir}/ros-kilted/opt/nav2_costmap_2d/lib*/ -mindepth 1 -maxdepth 1 \
  ! -name pkgconfig ! -name "python*" \
  | sed "s:%{buildroot}/::" >> files.list
find %{buildroot}/%{_libdir}/ros-kilted/opt/share/nav2_costmap_2d \
  -mindepth 1 -maxdepth 1 | sed "s:%{buildroot}/::" >> files.list

find %{buildroot}/%{_libdir}/ros-kilted/{lib*/pkgconfig,include/,cmake/,nav2_costmap_2d/include/,share/nav2_costmap_2d/cmake} \
  -mindepth 1 -maxdepth 1 | sed "s:%{buildroot}/::" >> files.list
# paths for vendor packages
find %{buildroot}/%{_libdir}/ros-kilted/nav2_costmap_2d/{lib*/pkgconfig,include/,cmake/,extra_cmake/,nav2_costmap_2d/include/,share/cmake} \
  -mindepth 1 -maxdepth 1 | sed "s:%{buildroot}/::" >> files.list
find %{buildroot}/%{_libdir}/ros-kilted/opt/nav2_costmap_2d/extra_cmake \
  -mindepth 1 -maxdepth 1 | sed "s:%{buildroot}/::" >> files.list
find %{buildroot}/%{_libdir}/ros-kilted/opt/nav2_costmap_2d/{lib*/pkgconfig,include/,cmake/,nav2_costmap_2d/include/,/share/cmake,/extra_cmake} \
  -mindepth 1 -maxdepth 1 | sed "s:%{buildroot}/::" >> files.list
find %{buildroot}/%{_libdir}/ros-kilted/opt/share/ament_index/resource_index \
  -mindepth 1 -maxdepth 1 | sed "s:%{buildroot}/::" >> files.list
find %{buildroot}/%{_libdir}/ros-kilted/opt/share/colcon-core/packages/ \
  -mindepth 1 -maxdepth 1 | sed "s:%{buildroot}/::" >> files.list
find %{buildroot}/%{_libdir}/ros-kilted/opt/share/nav2_costmap_2d/{hook,environment,cmake} \
  -mindepth 1 -maxdepth 1 | sed "s:%{buildroot}/::" >> files.list
find . -maxdepth 1 -type f -iname "*license*" | sed "s:^:%%license :" >> files.list



find %{buildroot}/%{_libdir}/ros-kilted/ -name *__rosidl_generator_py.so -type f -exec patchelf --remove-rpath  {} \;
# find %{buildroot}/%{_libdir}/ros-kilted/ -name *__rosidl_generator_py.so -type f -exec patchelf --force-rpath --add-rpath "%{_libdir}/ros2/lib" {} \;
find %{buildroot}/%{_libdir}/ros-kilted/ -name "*.so*" -type f -exec patchelf  --shrink-rpath --allowed-rpath-prefixes %{_libdir} {} \;

# replace cmake python macro in shebang
for file in $(grep -rIl '^#!.*@PYTHON_EXECUTABLE@.*$' %{buildroot}) ; do
  sed -i.orig 's:^#!\s*@PYTHON_EXECUTABLE@\s*:%{__python3}:' $file
  touch -r $file.orig $file
  rm $file.orig
done


echo "This is a package automatically generated with rosfed." >> README_FEDORA
echo "See  https://github.com/TarikViehmann/rosfed for more information." >> README_FEDORA
install -m 0644 -p -D -t %{buildroot}/%{_docdir}/%{name} README_FEDORA
echo %{_docdir}/%{name} >> files.list

%py3_shebang_fix %{buildroot}

# Also fix .py.in files
for pyfile in $(grep -rIl '^#!.*python.*$' %{buildroot}) ; do
  %py3_shebang_fix $pyfile
done

sort files.list | uniq > files.list.tmp && mv files.list.tmp files.list

%files -f files.list


%changelog
* Sun Jun 22 2025 Tarik Viehmann <viehmann@kbsg.rwth-aachen.de> - kilted.1.4.0-1
- Update to latest release
